/* Programmed by fkz */
/* $Id: reverse.c,v 1.4 1999/11/16 08:57:08 fkz Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

#define REPORTLEVEL 10

#ifdef REPORTLEVEL
int reportlevel = REPORTLEVEL;
#endif

/* reserved for option? */
char code_SJIS=TRUE;
char csvindex=FALSE;
char namearg=0;
char strip_body=FALSE;
char *output_name=NULL;
char crlf=FALSE; /* ԥ:TRUE crlf(dos)/FALSE lf(unix) */

/* definitions for constants */
#define BUFFER_NUMBER 32
#define BUFFER_NAME 512
#define BUFFER_ADDR 256
#define BUFFER_STAMP 32

#define HEADER_LINES 11
#define ALLOCSIZE 4096

/* definitions for work */
#define VARIABLE_NAME

#ifndef VARIABLE_NAME
char headername[] = "hoge.head";
char footername[] = "hoge.foot";
#else
char *headername = NULL;
char *footername = NULL;
#endif

struct MessageBody {
  struct MessageBody *Prev;
  char *body;
  size_t size;
};

void stuff(char *src){
  size_t offset=0;
  while(*(src + offset) != '\0'){
    *src=*(src + 1);
    offset++;
  }
  return;
}

void strip_delimiter(char *src){
  int c;
  size_t offset = 0;
  while((c = *(src + offset)) != '\0'){
    switch(c){
    case'\r':
    case'\n':
      stuff( src + offset );
      break;
    }
    offset++;
  }
  return;
}
     
void strip(char *src){
  int c;
  size_t offset = 0;
  while((c = *(src + offset))!='\0'){
    if(c >= 0x80){
	if((c >= 0xa1) && ( c <= 0xdf) && (code_SJIS==TRUE)){
	  /* SJISʤȾѥ */
	  /* 1byteʸʤΤǤʤˤ⤷ʤ */
	}else{
	  /* 2Хʸ1Х */
	  if(*(src + offset + 1) == '\0'){
	    /* 2Хܤ­ʤڤΤƤƽλ */
	    *(src + offset)='\0';
	    break;
	  }else{
	    /* 2Хܤ */
	    offset++;
	  }
	}
      }
    offset++;
  }
  return;
}

char *pick_number(char *dst,char *src,size_t buffsize){
  char *ptr;
  char *limit=NULL;

  limit=strstr(src,"</TABLE>");
  if(limit==NULL){
    if(reportlevel > 3){
      fprintf(stderr,"pick_number: </TABLE> not found.\n");
      fflush(stderr);
    }
    return(NULL);
  }
  ptr=strstr(src,"<b>");
  if(ptr != NULL){
    ptr += strlen("<b>");
  }
  if(ptr < limit){
    strncpy(dst,ptr,buffsize - 1);
    *(dst + buffsize - 1)='\0';
    ptr=strstr(dst,"</b>");
    if(ptr != NULL){
      *ptr='\0';
      ptr=dst;
    }else{
      ptr=NULL;
    }
  }else{
    ptr=NULL;
  }
  return(ptr);
}

void goodby(struct MessageBody *start){

  struct MessageBody *prev;
  struct MessageBody *current;

  current=start;
  while(1){
    if(current == NULL)
      break;
    if(current->body != NULL)
      free(current->body);
    prev=current->Prev;
    free(current);
    current=prev;
  }

  return;
}

char *resize(char *org,size_t size){
  char *ptr=NULL;

  if((ptr=realloc(org,size + ALLOCSIZE)) == NULL){
    if(reportlevel > 0){
      fprintf(stderr,"resize: Can't allocate memory.\n[ %ld bytes. ]\n",
	      (long)(size+ALLOCSIZE));
      fflush(stderr);
    }
    return(NULL);
  }else{
    return(ptr);
  }
}

int makeheader(FILE *stream){

  FILE *Header=NULL;
  int counter=0;
  char buffer[ ALLOCSIZE ];
  char *status;
  int terminate = FALSE;

  /*  TRUE */
  /* Ԥ FALSE ֤ */
  /* ֤Ūˤ̤ȵդοʤɡܥŪˤϤǤΤ */

  if( strip_body == FALSE ){

#ifdef VARIABLE_NAME
    /* VARIABLE_NAMEƤʤȤϸͤäˤʤ */
    headername = malloc( L_tmpnam + 1 );
    if(headername == NULL){
      /* headerѤtemporary̾ʤ */
      terminate=TRUE;
    }else{
      strncpy(headername,tmpnam(NULL), L_tmpnam );
    }
#endif    

    Header=fopen( headername , "w" );
    if(Header == NULL){
      terminate=TRUE;
      if(reportlevel > 2){
	fprintf(stderr,"Can't create header file.\n");
	fflush(stderr);
      }
    }
  }
  for(counter = 0; counter < HEADER_LINES ; counter++){
    status = fgets(buffer, (ALLOCSIZE - 1), stream);
    if(status == NULL){
      if(reportlevel > 1){
	fprintf(stderr,"makeheader: unexpected file end.\n");
	fflush(stderr);
      }
      terminate=TRUE;
      break;
    }
    if(strip_body == FALSE){
      if(Header != NULL)
	fputs(buffer,Header);
    }
  }
  if(strip_body == FALSE){
    if(Header != NULL)
      fclose(Header);
  }

  if(*(strstr(buffer,"\n") - 1)=='\r'){
    crlf=TRUE;
  }

  return( terminate );
}

int makefooter(char *src){
  FILE *Footer=NULL;
  int terminate=FALSE;

  if(strip_body == TRUE){
    return(terminate);
  }

#ifdef VARIABLE_NAME
/* VARIABLE_NAMEƤʤиͤʤΤäˤʤ */
  footername = malloc( L_tmpnam + 1);
  if(footername == NULL){
    /* footerѤtemporary̾ʤ */
    terminate = TRUE;
  }else{
    strncpy(footername,tmpnam(NULL), L_tmpnam );
  }
#endif    

  Footer=fopen( footername ,"w");
  if(Footer==NULL){
    if(reportlevel > 2){
      fprintf(stderr,"Can't create footerfile.\n");
      fflush(stderr);
    }
    return(terminate);
  }
  fputs(src,Footer);
  fclose(Footer);
  return;
}

char *loadmessage(FILE *stream){
  /* streamȯɤǥݥ󥿤֤ */
  /* NULL֤ä鼺 */

  char *buffer=NULL;
  char *ptr=NULL;
  size_t counter=0;
  size_t size=0;
  int c=0;

  while(1){
    if((size==0) || (counter >= size - 24)){
      ptr=resize(buffer,size);
      if(ptr==NULL){
	if(reportlevel > 0){
	  fprintf(stderr,"Can't allocate memory.\n");
	  fprintf(stderr,"\t%ld bytes\n",size + ALLOCSIZE);
	  fflush(stderr);
	  if(buffer != NULL)
	    free(buffer);
	  buffer=NULL;
	  break;
	}
      }else{
	buffer=ptr;
	size += ALLOCSIZE;
      }
    }
    c = fgetc(stream);
    if(c == EOF){
      break;
    }
    *(buffer + counter++) = c;
    if(c == '>'){
      if(counter > 18){
	/* strlen("<TABLE></TABLE><br>")=19 */
	if( strncmp( (char *)(buffer + counter - 12),"</TABLE><br>",12)==0){
	  fgets((buffer + counter),(size - counter - 1),stream);
	  /* ϲԥɤʤϤʤΤ */
	  /* ϥ顼ʤǤ */
	  /* Ĺʸ³ƤȲԤޤ */
	  strip( buffer + counter );
	  counter += strlen(buffer + counter);
	  break;
	}
      }
    }
  }
  if(buffer != NULL)
    *(buffer + counter)='\0';
  return(buffer);
}

struct MessageBody *read_loop(FILE *stream){

  struct MessageBody *current = NULL;
  struct MessageBody *prev = NULL;
  char terminate = FALSE;

  prev=NULL;

  while(1){
    current = malloc( sizeof(struct MessageBody));
    if(current == NULL){
      fprintf(stderr,"read_loop: Can't allocate memory.\n");
      fflush(stderr);
      if(prev!=NULL){
	terminate=TRUE;
	break;
      }
    }else{
      current->Prev = prev;
      current->body = loadmessage(stream);
    }
    if(current->body == NULL){
      /* ۾ｪλ(꤬ʤ) */
      free(current);
      terminate = TRUE;
      break;
    }else if(feof(stream) != 0){
      /* Ǹޤɤߤޤ */
      terminate=makefooter(current->body);
      if(terminate == TRUE){
	if(reportlevel > 2){
	  fprintf(stderr,"Can't make footer file.\n");
	  fflush(stderr);
	}
      }
      free(current);
      break;
    }
    prev=current;
  }
  /* ָŤȯι¤Τ֤ */
  if(terminate==TRUE){
    if(prev!=NULL)
      goodby(prev->Prev); /* goodby(NULL)Ϥʤˤ⤷ʤɤ */
    return(NULL);
  }
  return(prev);
}

int put_loop(struct MessageBody *start,FILE *stream){
  struct MessageBody *ptr;
  size_t offset=0;
  int c=0;
  int terminate = FALSE;

  ptr=start;

  while(1){
    offset=0;
    while((c = *(ptr->body + offset)) != '\0'){
      if(fputc(c,stream) == EOF){
	terminate = TRUE;
	if(reportlevel > 1){
	  fprintf(stderr,"put_loop: Can't write data.\n");
	  fflush(stderr);
	}
	break;
      }
#ifdef DEBUG
fflush(stream);
#endif
      offset++;
    }
    ptr=ptr->Prev;
    if(ptr==NULL)
      break;
  }
  goodby(start);
  return( terminate );
}

void usage(char *cmdname){
  printf("Usage: %s [-hb] [-o output] [sourcefile]\n",cmdname);
  printf("\tb: strip message body\n");
  printf("\to: specify output file\n");
  printf("\th: show help(this text)\n");
  return;
}

int optset(int argc,char *argv[]){
  int optcounter=1;
  char d=0;
  int terminate=0;

  while(optcounter < argc){
    if(*(argv[optcounter]) == '-'){
      d=*(argv[optcounter] + 1);
      switch(d){
      case's':
	code_SJIS=TRUE;
	break;
      case'e':
	code_SJIS=FALSE;
	break;
      case'b':
	strip_body=TRUE;
	break;
      case'o':
	if((optcounter + 1) < argc ){
	  output_name = argv[optcounter + 1];
	  optcounter++;
	}else{
	  fprintf(stderr,"-o require output_filename\n");
	  terminate=TRUE;
	}
	break;
      case'h':
	usage(argv[0]);
	terminate=TRUE;
	break;
      }
    }else{
      namearg=optcounter;
    }
    optcounter++;
  }
  return(terminate);
}

FILE *srcopen(int namearg,char *argv[]){
  if(namearg==0){
    return(stdin);
  }
  return(fopen(argv[namearg], "r"));
}

int putheader(FILE *stream){
  int terminate = FALSE;
  FILE *Header=NULL;
  char buffer[ ALLOCSIZE ];
  char *str=NULL;
  int counter=0;

  if(strip_body == FALSE){
    Header=fopen( headername , "r");
    if(Header == NULL){
      terminate=TRUE;
      if(reportlevel > 5){
	fprintf(stderr,"putheader: header file not found.\n");
	fflush(stderr);
      }
    }else{
      for(counter = 0 ; counter < HEADER_LINES ; counter++){
	str=fgets( buffer, (ALLOCSIZE - 1), Header);
	if(fputs(str, stream) == EOF){
	  terminate=TRUE;
	  break;
	}
      }
      if(Header != NULL){
	fclose(Header);
	remove( headername );
      }
    }
#ifdef VARIABLE_NAME
    free(headername);
#endif
  }

#ifdef DEBUG
fflush(stream);
#endif

  return(terminate);
}

int putfooter(FILE *stream){
  int terminate = FALSE;
  FILE *Footer=NULL;
  char buffer[ ALLOCSIZE ];
  char *str=NULL;

  if(strip_body == FALSE){
    Footer=fopen( footername , "r");
    if(Footer == NULL){
      terminate=TRUE;
      if(reportlevel > 5){
	fprintf(stderr,"putfooter: footer file not found.\n");
	fflush(stderr);
      }
    }else{
      while(1){
	str=fgets( buffer, (ALLOCSIZE - 1), Footer);
	if(str==NULL)
	  break;
	if(fputs(str, stream) == EOF){
	  terminate=TRUE;
	  break;
	}
      }
      if(Footer != NULL){
	fclose(Footer);
	remove( footername );
      }
    }
#ifdef VARIABLE_NAME
    free(footername);
#endif
  }
#ifdef DEBUG
fflush(stream);
#endif
  return(terminate);
}


int main(int argc,char *argv[]){
  FILE *stream;
  int terminate = 0;
  struct MessageBody *start=NULL;

  if((terminate=optset(argc,argv))==TRUE)
    return(0);
  stream = srcopen((int)namearg,argv);
  if(stream == NULL){
    fprintf(stderr,"Can't open %s\n",argv[namearg]);
    return(1);
  }
  terminate = makeheader(stream);
  if(terminate == FALSE){
    start = read_loop(stream);
    /* makefooter()read_loop()ǸƤФ */
    if(start == NULL){
      terminate = TRUE;
    }
  }

  if((stream != stdin) && (stream != NULL)){
    fclose(stream);
  }

  if(output_name != NULL){
    stream=fopen( output_name, "w");
    if(stream == NULL){
      terminate=TRUE;
      fprintf(stderr,"Can't open %s\n",output_name);
      fflush(stderr);
    }
  }else{
    stream = stdout;
  }

  if(terminate == FALSE){
    terminate=putheader(stream);
    if(terminate == FALSE)
      terminate=put_loop(start,stream);
    if(terminate == FALSE)
      terminate=putfooter(stream);
  }
  fflush(stream);
  if((stream != stdout) && (stream != NULL))
    fclose(stream);
    
  return(terminate);
}




  


